{-# LANGUAGE GADTs                 #-}
{-# LANGUAGE DataKinds             #-}
{-# LANGUAGE TypeFamilies          #-}
{-# LANGUAGE TypeOperators         #-}
{-# LANGUAGE StandaloneDeriving    #-}
{-# LANGUAGE ScopedTypeVariables   #-}
{-# LANGUAGE NoImplicitPrelude     #-}
{-# LANGUAGE UndecidableInstances  #-}
{-# LANGUAGE TemplateHaskell       #-}
{-# LANGUAGE QuasiQuotes           #-}
{-# LANGUAGE PolyKinds             #-}
{-# LANGUAGE UnicodeSyntax         #-}

-- | Defines commonly used functions and combinators
module Data.Function where

-- | Identity Function
id ∷ ∀ (a ∷ ★). a → a
id x = x

-- | Constant function
const ∷ ∀ (a ∷ ★) (b ∷ ★). a → b → a
const k _ = k

-- | Undefined
(⊥) ∷ ∀ a. a
(⊥) = (⊥)

infixr 0 $
infixr 9 ∘

-- | Function application operator
($) ∷ ∀ a b. (a → b) → a → b
f $ x = f x

-- | Function composition operator
(∘) :: ∀ a b c. (b → c) → (a → b) → a → c
f ∘ g = \x → f (g x)

